#!/usr/bin/php
<?php
$DEFAULT_AUTH_FILE="/home/gesa/wmic.conf";
$EVENT_TYPE=array(1,2,4,8,16);
$DELIMITER='§';

$STR_STATUS=array("OK","WARNING","CRITICAL","UNKNOWN");
$INT_STATUS=array_flip($STR_STATUS);
$PRIORITIES_STATES=array("CRITICAL","WARNING","UNKNOWN","OK");

function print_usage(){
?>
USAGE :
<?php echo basename($_SERVER['PHP_SELF']);?> -F config_file -w integer[,integer] -c integer[,integer] [OPTIONS]...
<?php echo basename($_SERVER['PHP_SELF']);?> -H host -P port -D db_name -T type -Q query -u user -p pass -w integer[,integer] -c integer[,integer]
<?php echo basename($_SERVER['PHP_SELF']);?> -h
<?php
}

function print_help(){
	print_usage();
?>

	-F, --file	config file whith database access, authentication and, or requests parameters

	-H, --host	host ip address 
	-P, --port	database port
	-D, --db	database name
	-T, --type	database type. Must be (mssql, pgsql, ora or mysql)
	-Q, --query	one query name (for conf file) or one sql request	
	
	-w, --warning	warning values  (MIN or MIN,MAX)
	-c, --critical	critical values (MIN or MIN,MAX)

	-u, --user	database user
	-p, --pass	database password

	-h, --help	print this message
<?php
}

function getParam($options,$name1,$name2,$default=null){
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

function isNull($value){
	return ( empty($value) || strtolower($value) == "null" || strtolower($value) == "none" || $value == null );
}

function exit_state($state,$msg=null,$usage=false){
        $STR_STATUS=$GLOBALS["STR_STATUS"];
        $INT_STATUS=$GLOBALS["INT_STATUS"];

        $ret=$state;
        if( is_string($state) ) $ret=$INT_STATUS[strtoupper($state)];
        else $state=$STR_STATUS[$ret];

        if( $msg != null ) echo "$state - $msg\n";
        if( $usage ) print_usage();
        exit($ret);
}

function calcul_state($a,$b=null){
        $STR_STATUS=$GLOBALS["STR_STATUS"];
        $INT_STATUS=$GLOBALS["INT_STATUS"];
        $PRIORITIES_STATES=$GLOBALS["PRIORITIES_STATES"];

        if(is_string($a) ) $a=$INT_STATUS[strtoupper($a)];
        if(is_string($b) ) $b=$INT_STATUS[strtoupper($b)];

        foreach($PRIORITIES_STATES as $value){
                $value = $INT_STATUS[$value];

                if( $value == $a || $value == $b ) return $value;
        }
        return $INT_STATUS["UNKNOWN"];
}

//*****Récupération des paramètres*****//
$SHORT_OPTS="U:A:H:l:s:p:w:c:h";
$LONG_OPTS=array("user:","authenticationfile:","host:","logfile:","source:","period:","warning:","critical:","help");

$options = getopt($SHORT_OPTS, $LONG_OPTS);

if ( isset($options["help"]) || isset($options["h"]) ){
        print_help();
        exit($RET_CODES["UNKNOWN"]);
}

$authentication_params  = getParam($options,"user","U");
$authentication_file    = getParam($options,"authenticationfile:","A");
$host                   = getParam($options,"host:","H");
$logfile                = getParam($options,"logfile:","l");
$source                 = getParam($options,"source:","s");
$period                 = getParam($options,"period:","p","1d");
$warning                = getParam($options,"warning:","w","2"); 
$critical		= getParam($options,"critical","c","1,4,8");

//Configuration des paramètres d'authentication
$authentication = "-A $DEFAULT_AUTH_FILE";
if( $authentication_file != null ) 	$authentication="-A $authentication_file"; 
if( $authentication_params != null ) 	$authentication="-U $authentication_params";

//Vérification de l'hôte
if( $host == null ) exit_script("unknown","--host (or -H)  parameter must be set",true);

//Configuration des paramètres de period
if( !preg_match("/^(\d+)([dh])$/",strtolower(trim($period)),$matches) ) exit_script("unknown","Incorrect --period (or p) parameter syntax",true);
$period_time=$matches[1];
$period_unit=$matches[2];

if( $period_unit == "h" ) 	$interval = $period_time * 3600;
else 				$interval = $period_time * 86400;	//3600 * 24

//Préparation des warning et critical
$warning=explode(",",$warning);
$critical=explode(",",$critical);

foreach(array_merge($warning,$critical) as $value){
	if( !in_array($value,$EVENT_TYPE) ){
		exit_script("unknown","--warning (or -w) and/or --critical (or -c) syntax error",true);
	}
}

//Calcul de l'intervalle
$now=time();
$datestart=new DateTime();
$datestart->setTimestamp($now-$interval);

$wmi_date=$datestart->format("YmdHis.000000");

$gmt=$datestart->format("Z")/60;
if( $gmt < 0 ) 	$wmi_date=$wmi_date."-".abs($datestart->format("Z")/60); 
else		$wmi_date=$wmi_date."+".abs($datestart->format("Z")/60);

//Préparation de la commande
$where="TimeGenerated > '$wmi_date'";
if( ! isNull($logfile) ) $where="$where and LogFile='$logfile'";
if( ! isNull($source) )  $where="$where and SourceName='$source'";

$select="EventType,InsertionStrings,Logfile,Message,RecordNumber,SourceName,Type,TimeGenerated";
$wmic_command="wmic --delimiter=$DELIMITER $authentication //$host ".'"'."select $select from Win32_NTLogEvent where $where".'"';

//Récupération des données
exec("$wmic_command 2>/dev/null",$output,$ret);
if( $ret != 0 ) exit_script("unknown",implode("\n",$output));

array_shift($output); //on n'a pas besoin de la ligne "CLASS: Win32_NTLogEvent"
$headers=array_flip(explode("$DELIMITER",array_shift($output)));

//On reorganise la sortie afin d'eviter le problème des retours à la ligne dans les messages
$nchars=count($headers)-1;
$line="";
$nb=0;

$output2=array();
foreach($output as $value){
	$line="$line $value\n";
	$nb+=substr_count($value,$DELIMITER);

	if($nb==$nchars){
	        array_push($output2,$line);
	       $line="";
 	       $nb=0;
	}
}

//Affichage et préparation de la valeur de retour
$ret_val=$INT_STATUS["OK"];
foreach($output2 as $line){
	$cells=explode($DELIMITER,$line);

	$EventType		= $cells[$headers["EventType"]];
        $InsertionStrings      	= $cells[$headers["InsertionStrings"]];
        $Logfile      		= $cells[$headers["Logfile"]];
        $Message      		= $cells[$headers["Message"]];
        $RecordNumber      	= $cells[$headers["RecordNumber"]];
        $SourceName      	= $cells[$headers["SourceName"]];
        $TimeGenerated      	= $cells[$headers["TimeGenerated"]];
        $Type      		= $cells[$headers["Type"]];

	preg_match("/^(\d+)\.(\d+)([\+-])(\d+)$/",$TimeGenerated,$matches);
	$dt	= $matches[1];
	$ms	= $matches[2];
	$sign	= $matches[3];

	$gmt=sprintf("%'02d",$matches[4]/60);
	$gmt="$sign$gmt"."00";

	$datetime=DateTime::createFromFormat('YmdHis.u.P',"$dt.$ms.$gmt");
	$eventdate=$datetime->format("Y-m-d H:i:s.u")." UTC";

	$state = $INT_STATUS["OK"];
	if ( in_array($EventType,$critical)) $state = $INT_STATUS["CRITICAL"];
	else  if ( in_array($EventType,$warning )) $state = $INT_STATUS["WARNING"];
	$ret_val=calcul_state($state,$ret_val);
	
	if( $state != $INT_STATUS["OK"] ) echo $STR_STATUS[$state]." - $eventdate $Logfile:$SourceName Status:$Type $InsertionStrings \n".$Message."\n\n";
}
if( $ret_val == $INT_STATUS["OK"] ) echo "OK - No event in warning or critical state found since ".$datestart->format("Y-m-d H:i:s O")."\n";

exit($ret_val);
